<button mat-icon-button
        class="filter-icon filter-icon-before"
        title="Filter"
        disableRipple
        [ngClass]="{'filter-icon-active': filterSetting.filterVals.columns[column] && filterSetting.filterVals.columns[column].length}"
        [matMenuTriggerFor]="filterMenu">
  <mat-icon>filter_list</mat-icon>
</button>
<mat-menu #filterMenu
          yPosition="below"
          xPosition="after"
          overlapTrigger="false"
          class="filter-panel">
  <ng-template matMenuContent>
    <div (click)="$event.stopPropagation();">
      <div *ngIf="filterType!=='dropdown'" style="display: flex; align-items: center;">
        <mat-icon class="app-icon">search</mat-icon>
        <input mat-menu-item type="search"
               disableRipple
               matInput
               placeholder="Filter..."
               [(ngModel)]="filterSetting.filterVals.columns[column]"
               (ngModelChange)="applyFilter()">
      </div>
      <div *ngIf="filterType==='dropdown'" class="checkbox-small">

        <div class="mat-selection-list selectall-checkbox-separator"
             dense
             >
          <div class="mat-list-item mat-list-option"
               role="option"
               aria-selected="false"
               aria-disabled="false">
            <div class="mat-list-item-content">
              <mat-checkbox disableRipple
                            (change)="$event ? masterToggle(matSelectionListRef) : null"
                            [checked]="filterSetting.filterVals.columns[column].length && isAllSelected()"
                            [indeterminate]="filterSetting.filterVals.columns[column].length && !isAllSelected()">
                <span class="mat-list-text">Select All</span></mat-checkbox>
            </div>
          </div>
        </div>
        <mat-divider></mat-divider>
        <mat-selection-list disableRipple
                            dense
                            #matSelectionListRef
                            [(ngModel)]="filterSetting.filterVals.columns[column]"
                            (ngModelChange)="applyFilter()"
                            style="padding-top:0">
          <mat-list-option checkboxPosition="before"
                           *ngFor="let value of filterSetting.filterParams[column].values"
                           [value]="value">
            {{ filterSetting.filterParams[column].valueFormatter? filterSetting.filterParams[column].valueFormatter(value) : value}}
          </mat-list-option>
        </mat-selection-list>
      </div>
    </div>
  </ng-template>
</mat-menu>